/**
 * 
 */

(function(win) {
	//常量
	var userAgent = navigator.userAgent,
		app = navigator.appVersion;
	var IS_IOS = (userAgent.indexOf('Safari') > -1 && !!userAgent.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/));
	var LANGUAGE = (navigator.browserLanguage || navigator.language).toLowerCase(); // 辨别移动终端的语言：zh-cn、en-us、ko-kr、ja-jp
	var ANISHOW_AUTO = {
		aniShow: IS_IOS ? "pop-in" : "zoom-fade-out",
		duration: 200
	};
	var ANISHOW_SLIDE = {
		aniShow: "pop-in",
		duration: 200
	};
	//存储
	win.storage = localStorage;

	var app = {
		/*工具方法*/
		//消息
		msgBox: function(msg, fun, title) {
			if(curView && curView.isVisible()) {
				plus.nativeUI.alert(msg, fun, title);
			}
		},
		//自动消失消息
		toast: function(msg) {
			plus.nativeUI.toast(msg);
		},
		//confirm
		confirm: function(msg, okFun) {
			mui.confirm(msg, "", ["取消", "确定"], function(e) {
				if(e.index == 1) {
					okFun && okFun();
				}
			});
		},
		/*导航方法*/
		backIndex: function(fun) {
			//显示首页一般都因返回操作
			var cur = plus.webview.currentWebview();
			var fa = cur.opener();
			while(fa.id != "HBuilder" && fa.opener()) {
				var tmp = fa.opener();
				if(fa.preload) {
					fa.hide();
				} else {
					fa.close();
				}
				fa = tmp;
			}
			fun&&fun(fa);
			mui.back();
		},
		showAbout: function(para) {
			this._autoShow("about", para);
		},
		showLogin: function(para) {
			this._autoShow("login", para);
		},
		showRegister: function(para) {
			this._autoShow("register", para);
		},
		showPassword: function(para) {
			this._autoShow("password", para, true);
		},
		showPWDSet: function(para) {
			this._autoShow("password_set", para, true);
		},
		showPWDFind: function(para) {
			this._autoShow("password_find", para);
		},
		showWallet: function(para) {
			this._autoShow("wallet", para, true);
			//			mui.openWindow({
			//				url: "wallet.html",
			//				id: "wallet",
			//				show: ANISHOW_AUTO
			//			});
		},
		showPersonal: function(para) {
			this._autoShow("personal", para, true);
		},
		showEmail: function(para) {
			this._autoShow("email", para, true);
		},
		showQRCode: function(para) {
			this._autoShow("qr_code", para, true);
		},
		showLocation: function(para) {
			this._autoShow("location", para);
		},
		showPrintTask: function(para) {
			this._autoShow("print_task", para, true);
		},
		showPrintConfig: function(para) {
			this._autoShow("print_config", para, true);
		},
		showPreview: function(para) {
			this._autoShow("preview", para, true);
		},
		showPrintConfirm: function(para) {
			this._autoShow("print_confirm", para, true);
		},
		showPrintRec: function(para) {
			this._autoShow("print_rec", para, true);
		},
		showScanTask: function(para) {
			this._autoShow("scan_task", para, true);
		},
		showScanConfirm: function(para) {
			this._autoShow("scan_confirm", para, true);
		},
		showScanProfile: function(para) {
			this._autoShow("scan_profile", para);
		},
		showCopyRecord: function(para) {
			this._autoShow("copy_record", para, true);
		},
		showCopyProfile: function(para) {
			this._autoShow("copy_profile", para);
		},
		showInfo: function(para) {
			this._autoShow("info", para);
		},
		showShopList: function(para) {
			this._autoShow("shop_list", para);
		},
		showRecharge: function(para) {
			this._autoShow("recharge", para, true);
		},
		showWatch: function(para) {
			this._autoShow("watch", para);
		},
		showPrintEmail: function(para) {
			this._autoShow("print_email", para);
		},
		showAuthResult: function(para) {
			this._autoShow("auth_result", para);
		},
		/*页面初始化系列方法*/
		//页面显示时回调 需plusready
		onPageLoad: function(fun) {
			if(typeof(fun) != "function" || !plus) {
				console.log("onPageLoad fail");
				return;
			}
			if(!curView) {
				app.curView = curView = plus.webview.currentWebview();
			}
			if(curView.preload) {
				if(curView.isVisible()) { //预加载时已显示
					fun(curView.detail || {});
				}
				win.addEventListener("unishow", function(ev) {
					fun(ev.detail || {});
				});
			} else {
				fun(curView.detail || {});
			}
		},
		//预加载页面显示前回调
		onPreload: function(fun) {
			if(typeof(fun) != "function" || !plus) {
				console.log("onPreload fail");
				return;
			}
			if(!curView) {
				app.curView = curView = plus.webview.currentWebview();
			}
			this._reloadFun = fun;
			if(curView.preload) { //预加载
				if(curView.isVisible()) { //预加载时已显示
					this.preload(curView.detail || {});
				}
			} else {
				this.preload(curView.detail || {});
			}
		},
		preload: function(para) {
			if(typeof(this._reloadFun) == "function") {
				this._reloadFun(para || {});
			}
		},
		//页面显示状态变化回调
		onUpdateState: function(fun) {
			if(typeof(fun) == "function") {
				if(this.isUpdated) {
					fun();
				}
				this._upStateFun = fun;
			}
		},
		//更新状态(显示和返回时都会触发)
		updateState: function() {
			if(!this.isUpdated) {
				this.isUpdated = true;
			}
			app.isLogin();
			if(typeof(this._upStateFun) == "function") {
				this._upStateFun();
			}
		},
		//id=webviewID 且页面需[id].html;para=传参 预加载后取参监听unishow
		_autoShow: function(id, para, needLogin) {
			if(!curView || !curView.isVisible()) {
				return;
			}
			console.log("show_page(" + curView.id + " --> " + id + ")");
			if(needLogin && !app.isLogin()) {
				app.showLogin();
				return;
			}
			para = para || {};
			para._from = curView.id;
			var p = plus.webview.getWebviewById(id);
			if(p) {
				if(p.preload) {
					p.evalJS("app.preload(" + JSON.stringify(para) + ")");
				}
				mui.fire(p, "unishow", para);
			}
			mui.openWindow({
				url: id + ".html",
				id: id,
				show: ANISHOW_AUTO,
				extras: {
					detail: para
				}
			});
		}
	};
	/*-------初始化---------*/
	var curView;
	var fromView;

	function initDom() {
		var list = document.querySelectorAll(".init-waiting");
		for(var i = 0; i < list.length; i++) {
			list[i].innerHTML = "<div class='u-dft-waiting'><img src='img/dft-waiting.gif'><p>正在加载</p></div>";
		}
		var vList = document.querySelectorAll(".init-none");
		for(var i = 0; i < vList.length; i++) {
			vList[i].value = "";
		}
	}
	initDom();
	mui.plusReady(function() {
		plus.screen.lockOrientation('portrait-primary'); //锁定竖屏
		if(!curView) {
			app.curView = curView = plus.webview.currentWebview();
		}
		if(curView.detail && curView.detail._from) {
			app.fromView = fromView = plus.webview.getWebviewById(curView.detail._from);
		}
		curView.addEventListener("hide", initDom);
		//初始化状态
		if(curView.preload) { //预加载
			if(curView.isVisible()) { //预加载时已显示
				app.updateState();
			}
			win.addEventListener("unishow", function(ev) {
				if(ev.detail && ev.detail._from) {
					app.fromView = fromView = plus.webview.getWebviewById(ev.detail._from);
				}
				app.updateState();
			});
			curView.addEventListener("hide", function() {
				if(fromView) {
					fromView.evalJS("app.updateState()");
					mui.fire(fromView, "uniback", {
						from: curView.id
					});
				}
			});
		} else { //非预加载
			app.updateState();
			curView.addEventListener("close", function() {
				if(fromView) {
					fromView.evalJS("app.updateState()");
					mui.fire(fromView, "uniback", {
						from: curView.id
					});
				}
			});
		}
	});
	//处理超时
	win.addEventListener("sessionout", function(ev) {
		var rlt = ev.detail;
		var pid = storage["acc"] && JSON.parse(storage["acc"]).pid;
		if(pid) {
			proj.cac.authToken(pid, storage["token"] || "", function() {
				app.msgBox("会话超时重连，请重试");
			}, function(rlt) {
				var pwd = storage["pwd"];
				if(pwd != undefined && pwd != null) {
					proj.cac.login(pid, pwd, null, function() {
						app.msgBox("会话超时重连，请重试");
					}, function() {
						pro.clearState();
						app.msgBox("会话超时,请重新登录", function() {
							app.showLogin();
						});
					});
				} else {
					pro.clearState();
					app.showLogin();
				}
			});
		} else {
			pro.clearState();
			app.showLogin();
		}
	});

	/*-------end---------*/

	/*-------上传下载相关---------*/
	// 从相册中选择图片
	app.galleryImg = function(fun) {
		if(!app.isLogin()) {
			app.showLogin();
			return;
		}
		plus.gallery.pick(fun || function(path) {
			uploadFile(path);
		});
	};
	//拍照
	app.cameraImg = function() {
		var cmr = plus.camera.getCamera();
		if(cmr) {
			cmr.captureImage(function(path) {
				console.log(path);
				uploadFile(path);
			}, function(error) {
				console.log(error.message);
			});
		}
	};
	app.getIOSThirdFile = function(para) {
		//获取第三方传来的文件
		if(plus.os.name == "iOS") {
			if(plus.runtime.arguments != "") {
				var arg = plus.runtime.arguments;
				if(arg.substr(0, 4) == "file") {
					if(window.iosThirdFile != arg || para.retry) {//retry=true 不重复性检验
						window.iosThirdFile = arg; //保存文件地址，防止重复读取
						if(para.auth == "no" || para.auth == "fail") {
							app.msgBox("上传文件打印前需登录", function() {
								app.showLogin({
									sendThirdFile: true
								});
							});
						} else if(para.auth == "suc") {
							app.confirm("是否上传本文件打印", function() {
								uploadFile(arg);
							});
						} else if(para.auth == "err") {
							app.msgBox("连接异常，无法打印");
						}
					}
				}
			}
		}
	};

	function uploadFile(path) {
		var uploader = getUploader([{
			path: path
		}], function(f, status) {
			uploadComplete(f.responseText, status);
		});
		showUpOrDowDLG("上传文件", function() {
			app.toast("取消上传");
			uploader.abort();
		});
		var bar = mui("#u-updowbar");
		uploader.start();
		var it = setInterval(function() {
			if(uploader.uploadedSize) {
				var v = parseInt(uploader.uploadedSize / uploader.totalSize * 100);
				if(bar.length == 0 || v > 99) {
					clearInterval(it);
				}
				bar.progressbar().setProgress(v);
				var upSize = document.getElementById("u-uploadsize");
				if(upSize) {
					upSize.innerText = app.getFileSize(uploader.uploadedSize) + "/" + app.getFileSize(uploader.totalSize);
				}
			}
		}, 500);
	}
	//选择文件
	app.getFile = function(ipt) {
		if(IS_IOS) return;
		if(!app.isLogin()) {
			app.showLogin();
			return;
		}
		//		var ipt = document.createElement("input");
		//		ipt.type = "file";
		//		ipt.click();
		plus.nativeUI.showWaiting();
		var main = plus.android.runtimeMainActivity();
		var Intent = plus.android.importClass('android.content.Intent');
		var Build = plus.android.importClass('android.os.Build');
		var intent = new Intent(Intent.ACTION_GET_CONTENT);
		//		if (Build.VERSION.SDK_INT <19) {
		//			intent.setAction(Intent.ACTION_GET_CONTENT);
		//		}else {
		//			intent.setAction(Intent.ACTION_OPEN_DOCUMENT);
		//		}
		intent.setType("*/*");
		intent.addCategory(Intent.CATEGORY_OPENABLE);
		main.onActivityResult = function(requestCode, resultCode, data) {
			if(resultCode == this.RESULT_OK) {
				var Uri = plus.android.importClass('android.net.Uri');
				var uri = new Uri();
				uri = data.getData();
				var path;
				if(Build.VERSION.SDK_INT > 18 && uri.getAuthority() == "com.android.providers.media.documents") { //android>4.4多媒体
					var MediaStore = plus.android.importClass("android.provider.MediaStore");
					var proj = [];
					proj.push(MediaStore.Images.Media.DATA);
					var CursorLoader = plus.android.importClass("android.content.CursorLoader");
					var loader = new CursorLoader(this, uri, proj, null, null, null);
					var Cursor = plus.android.importClass("android.database.Cursor");
					var cursor = new Cursor();
					cursor = loader.loadInBackground();
					//var cursor = aty.managedQuery(uri, proj, null, null, null); 
					var column_index = cursor.getColumnIndexOrThrow(MediaStore.Images.Media.DATA);
					cursor.moveToFirst();
					path = cursor.getString(column_index);
				} else {
					path = uri.toString();
				}
				uploadFile(path);
			}
		}
		main.startActivityForResult(intent, 1);
		plus.nativeUI.closeWaiting();
		return;
		//下边的实现方式简直是垃圾 input控件在安卓下总是不能正确获取到文件
		ipt.addEventListener("change", function() {
			if(this.files.length > 0 && this.files[0].name && this.files[0].size > 0) { //
				var fd = new FormData();
				fd.append("fileToUpload", this.files[0]);
				var xhr = new XMLHttpRequest();
				//进度
				xhr.upload.addEventListener("progress", uploadProgress, false);
				//完成
				xhr.addEventListener("load", function(evt) {
					uploadComplete(evt.target.responseText, evt.target.status);
				}, false);
				//错误
				xhr.addEventListener("error", function(evt) {
					uni.closeDLG();
					console.log("上传文件出错:" + evt.target.responseText);
					app.msgBox("上传文件出错");
				}, false);
				//撤销
				xhr.addEventListener("abort", function() {
					uni.closeDLG();
					console.log("撤销上传文件");
				}, false);
				xhr.open("POST", proj.upload.getUrl()); //修改成自己的接口
				//打开上传界面
				showUpOrDowDLG("上传文件", function() {
					app.toast("取消上传");
					xhr.abort();
				});
				console.log("开始上传")
				xhr.send(fd);
				ipt.value = "";
			} else {
				app.msgBox("无法读取到文件");
			}
		});
	};

	function getUploader(files, callback) {
		if(files.length <= 0) {
			app.msgBox("没有添加上传文件！");
			return;
		}
		var task = plus.uploader.createUpload(proj.upload.getUrl(), {
				method: "POST"
			},
			callback
		);
		var f = files[0];
		console.log(f.path);
		task.addFile(f.path, {
			key: "testdoc"
		});
		return task;
	}

	function showUpOrDowDLG(title, cancel) {
		//		layerOpen({
		//			title: title || "文件传送",
		//			content: "<div id='u-updowbar' class='mui-progressbar'><span></span></div><div id='u-uploadsize' class='mui-text-center'>0/0</div>",
		//			btn: ["取消"],
		//			event: [cancel],
		//			style: {
		//				content: "padding:10px 5px;"
		//			}
		//		});
		uni.msgDLG("<div id='u-updowbar' class='mui-progressbar'><span></span></div><div id='u-uploadsize' class='mui-text-center'>连接中...</div>",
			title || "文件传送",
			undefined,
			cancel,
			"",
			"取消", {
				content: "padding:10px 5px;"
			},
			(cancel ? true : false)
		);
	}

	function uploadProgress(evt) {
		if(evt.lengthComputable) {
			var bar = mui("#u-updowbar");
			if(bar.length > 0) {
				var v = Math.round(evt.loaded * 100 / evt.total);
				bar.progressbar().setProgress(v);
				document.getElementById("u-uploadsize").innerText = app.getFileSize(evt.loaded) + "/" + app.getFileSize(evt.total);
			}
		}
	}

	function uploadComplete(rltText, status) {
		if(!document.getElementById("u-uploadsize")) {
			return; //由于uploader.abort()取消上传任务无效，暂时通过检查上传进度条是否还在来判断是否被取消
		}
		uni.closeDLG();
		setTimeout(function() { //防止残影 等待320ms
			if(status == 200) {
				var rlt = JSON.parse(rltText);
				if(rlt && rlt.ret == 1) {
					console.log("上传文件成功:" + rltText);
					app.showPrintConfig({
						file: rlt.data
					});
					return;
				}
			} else {
				console.log("上传文件失败：" + status + "/" + rltText);
				var rlt = JSON.parse(rltText);
				if(rlt.msg) {
					app.msgBox(rlt.msg)
				} else {
					app.msgBox("上传文件失败");
				}
			}
		}, 320);
	}
	//下载文件
	app.downloadFile = function(url, filename, suc, para) {
		if(!app.isLogin()) {
			app.showLogin();
			return;
		}
		para = para || {};
		var path = "_downloads/" + filename;
		url = encodeURI(url);
		console.log("下载：" + url);
		plus.io.resolveLocalFileSystemURL(path, function(entry) {
			console.log("已下载");
			if(suc) suc(path, entry);
		}, function() {
			var dtask = plus.downloader.createDownload(url, {
				filename: path
			}, function(dl, status) {
				if(status == 200) {
					plus.io.resolveLocalFileSystemURL(path, function(entry) {
						if(suc) suc(path, entry);
					});
				} else {
					app.toast("下载失败");
					console.log("下载失败");
				}
			});
			showUpOrDowDLG("下载文件", para.type == "must" ? null : function() {
				app.toast("取消下载");
				dtask.abort();
			});
			dtask.start();
			dtask.addEventListener("statechanged", function(task, status) {
				if(!dtask) {
					return;
				}
				switch(task.state) {
					case 1: // 开始
						console.log("开始下载...");
						break;
					case 2: // 已连接到服务器
						console.log("链接到服务器...");
						break;
					case 3: // 已接收到数据
						var bar = mui("#u-updowbar");
						if(bar.length > 0) {
							var v = Math.round(task.downloadedSize * 100 / task.totalSize);
							bar.progressbar().setProgress(v);
							document.getElementById("u-uploadsize").innerText = app.getFileSize(task.downloadedSize) + "/" + app.getFileSize(task.totalSize);
						}
						break;
					case 4: // 下载完成
						console.log("下载完成！");
						uni.closeDLG();
						break;
					default:
						console.log(task.state);
						break;
				}
			});
		});

	};
	/*-------end---------*/

	//verify
	var vfy = {
		//手机号
		isPhone: function(v) {
			if(v.length != 11 || isNaN(parseInt(v))) {
				app.msgBox("请输入正确的手机号码");
				return false;
			}
			return true;
		},
		//邮箱
		isEmail: function(v) {
			if(!uni.ckEmail(v)) {
				app.msgBox("请输入正确的邮箱格式");
				return false;
			}
			return true;
		},
		//图片
		isImg: function(v) {
			return uni.isImg(v);
		}
	};
	app.vfy = vfy;
	//convert
	var cvt = {
		//日期
		toDate: function(i) {
			i = i + "";
			var y = i.substr(0, 4);
			var m = i.substr(4, 2);
			var d = i.substr(6, 2);
			return y + "-" + m + "-" + d;
		},
		//时间
		toTime: function(i) {
			i = i + "";
			if(i.length < 6) {
				i = ("000000" + i).substr(-6);
			}
			var h = i.substr(0, 2);
			var m = i.substr(2, 2);
			return h + ":" + m;
		},
		//距离
		toDistance: function(m) {
			var ret = "0";
			if(m > 0) {
				if(m > 1000) {
					var arr = ((m / 1000) + "").split('.');
					if(arr.length == 2) {
						var z = arr[0];
						var x = arr[1];
						x = x.substr(0, 2);
						ret = z + "." + x + "km";
					}
				} else {
					ret = m + "m";
				}
			}
			return ret;
		},
		//加星号
		getEncName: function(str) {
			if(str.length < 11) {
				return str;
			}
			var i = str.substr(0, 3);
			var k = str.substr(7);
			return i + "****" + k;
		},
		//根据拓展名获取图标
		getFmtIcon: function(fmt) {
			var suf = "blue icon-suolvetu"
			if(fmt == "pdf") {
				suf = "deepred icon-pdf";
			} else if(fmt == "txt") {
				suf = "blue icon-txt";
			} else if(fmt == "xls" || fmt == "xlsx") {
				suf = "blue icon-excel";
			} else if(fmt == "doc" || fmt == "docx") {
				suf = "blue icon-word";
			} else if(fmt == "ppt" || fmt == "pptx") {
				suf = "blue icon-ppt";
			} else if(fmt == "jpg" || fmt == "jpeg" || fmt == "png" || fmt == "gif") {
				suf = "green icon-img";
			}
			return suf;
		}
	};
	app.cvt = cvt;
	//Login
	app.login = function(pid, pwd, sms) {
		proj.cac.login(pid, pwd, sms, function(rlt) {
			if(pwd == "") {
				app.msgBox("登录成功，请修改密码", function() {
					app.fromView.evalJS("app.showPassword()");
					mui.back();
				});
			} else {
				mui.back();
			}
		});
	};
	app.isLogin = function() {
		if(localStorage["acc"]) {
			pro.acc = JSON.parse(localStorage["acc"]);
		} else {
			pro.acc = null;
		}
		return pro.acc ? true : false;
	};
	//验证码
	app.regVerify = function(dom, pidDom) {
		dom.addEventListener("tap", function() {

			var phone = (pidDom && pidDom.value) || (pro.acc && pro.acc.pid); //pro.acc.phone 手机不全
			if(!phone) {
				app.msgBox("请输入手机号");
				return;
			}
			proj.util.sendSMS(phone, function() {
				app.toast("验证码已发送");
				var t = 60;
				dom.disabled = "disabled";
				var id = setInterval(function() {
					dom.innerText = "重新发送" + t--;
					if(t < 0) {
						dom.disabled = "";
						dom.innerText = "获取验证码";
						clearInterval(id);
					}
				}, 1000);
			}, function(rlt) {
				app.msgBox(rlt.msg);
			});
		});
	};
	//获取余额
	app.getBalance = function(suc, para) {
		proj.cac.getBalance(para, function(rlt) {
			if(suc) suc(app.cvtFee(rlt.data.dwBalance), rlt.data);
		});
	};
	//获取收费标准
	app.getPrintFeeSTD = function(suc, para) {
		proj.print.getFeeSTD(function(rlt) {
			storage["print_fee_std"] = rlt.data;
			if(suc) suc(rlt);
		}, para);
	};
	//支付
	app.pay = function(payChanel, sum, suc) {
			if(!isNaN(parseFloat(sum))) {
				var arr = sum.split('.');
				var zs = parseInt(arr[0] || 0);
				var xs = arr[1] || "00";
				if(xs.length > 2) {
					app.toast("金额只支持到分");
					return;
				} else if(xs.length == 1) {
					xs += "0";
				}
				if(zs >= 0) {
					var fee = zs * 100 + parseInt(xs);
					if(checkPayChanel(payChanel)) {
						var type = payChanel.id;
						if(type == "wxpay") { //微信
							proj.pay.payWX(fee, function(rlt) {
								console.log(JSON.stringify(rlt.data));
								plus.payment.request(payChanel, rlt.data, function(result) {
									console.log(JSON.stringify(result));
									suc && suc(result, rlt.data);
								}, function(e) {
									console.log(JSON.stringify(e));
									app.toast("支付失败");
								});
							});
						} else if(type == "alipay") { //支付宝
							proj.pay.alipay(fee, function(rlt) {
								plus.payment.request(payChanel, rlt.data, function(result) {
									console.log(JSON.stringify(result));
									suc && suc(result, rlt.data);
								}, function(e) {
									console.log(JSON.stringify(e));
									var msg = e.message.substr(e.message.indexOf(']') + 1);
									if(msg) {
										app.toast(msg);
									} else {
										app.toast("支付失败");
									}
								});
							});
						} else { //不支持的支付类型
							app.msgBox("不支持的支付类型");
						}
					}
					return;
				}
			}
			app.toast("输入金额有误");
		}
		// 检测支付通道是否安装支付服务
	function checkPayChanel(pc) {
		if(!pc) {
			return false;
		}
		if(!pc.serviceReady) {
			var txt = null;
			switch(pc.id) {
				case "alipay":
					txt = "检测到系统未安装“支付宝快捷支付服务”，无法完成支付操作，是否立即安装？";
					break;
				default:
					txt = "系统未安装“" + pc.description + "”服务，无法完成支付，是否立即安装？";
					break;
			}
			plus.nativeUI.confirm(txt, function(e) {
				if(e.index == 0) {
					pc.installService();
				}
			}, pc.description);
			return false;
		} else {
			return true;
		}
	}
	//runtime
	app.quit = function() {
		plus.runtime.quit();
	};
	//tools
	app.getFileSize = function(size) {
		var fileSize = 0;
		if(size > 1024 * 1024)
			fileSize = (Math.round(size * 100 / (1024 * 1024)) / 100).toString() + 'MB';
		else
			fileSize = (Math.round(size * 100 / 1024) / 100).toString() + 'KB';
		return fileSize;
	}
	app.cvtFee = function(fee) {
		var f = fee % 100;
		if(f == 0) f = "00";
		else if(f > 9) f = (f + "0").substr(0, 2);
		else f = "0" + f;
		return parseInt(fee / 100) + "." + f;
	}
	app.get1970DateTime = function(sec, fmt) {
		if(!sec) return "";
		sec = parseInt(sec);
		var dt1970 = new Date(1970, 0, 01, 08, 0, 0);
		dt1970.setSeconds(dt1970.getSeconds() + sec);
		return dt1970.format(fmt || "yyyy-MM-dd HH:mm");
	}
	win.app = app;
})(window);